
	; ----------------------------------------
	; Code operations used by Froth 'compiler'
	; ----------------------------------------

; MOV_EBX_i32		mov	ebx, i32
; MOV_EAX_xEAXi8	mov	eax, [eax + i8]
; MOVZX_EAX_bxEAXi8	movzx	eax, byte ptr [eax + i8]
; MOVZX_EAX_wxEAXi8	movzx	eax, word ptr [eax + i8]
; MOV_EAX_xEBXi8	mov	eax, [ebx + i8]
; MOV_EAX_xESIi8	mov	eax, [esi + i8]
; MOV_EBX_xESIi8	mov	ebx, [esi + i8]
; MOV_xEAXi8_EBX	mov	[eax + i8], ebx
; MOV_xEAXi8_BX		mov	[eax + i8], bx
; MOV_xEAXi8_BL		mov	[eax + i8], bl
; MOV_xEBXi8_EAX	mov	[ebx + i8], eax
; MOV_xEBXi8_AX		mov	[ebx + i8], ax
; MOV_xEBXi8_AL		mov	[ebx + i8], al
; MOV_xEAXi8_i32	mov	dword ptr [eax + i8], i32
; MOV_wxEAXi8_i16	mov	word ptr [eax + i8], i16
; MOV_bxEAXi8_i8	mov	byte ptr [eax + i8], i8
; ADD_xEAXi8_EBX	add	[eax + i8], ebx
; SUB_xEAXi8_EBX	sub	[eax + i8], ebx
; ADD_xEBXi8_EAX	add	[ebx + i8], eax
; SUB_xEBXi8_EAX	sub	[ebx + i8], eax
; ADD_xESIi8_EAX	add	[esi + i8], eax
; SUB_xESIi8_EAX	sub	[esi + i8], eax
; AND_xESIi8_EAX	and	[esi + i8], eax
; OR_xESIi8_EAX		or	[esi + i8], eax
; XOR_xESIi8_EAX	xor	[esi + i8], eax
; ADD_xESIi8_i8		add	dword ptr [esi + i8], i8
; ADD_xESIi8_i32	add	dword ptr [esi + i8], i32
; SUB_xESIi8_i8		sub	dword ptr [esi + i8], i8
; SUB_xESIi8_i32	sub	dword ptr [esi + i8], i32
; AND_xESIi8_i8		and	dword ptr [esi + i8], i8
; AND_xESIi8_i32	and	dword ptr [esi + i8], i32
; OR_xESIi8_i8		or	dword ptr [esi + i8], i8
; OR_xESIi8_i32		or	dword ptr [esi + i8], i32
; XOR_xESIi8_i8		xor	dword ptr [esi + i8], i8
; XOR_xESIi8_i32	xor	dword ptr [esi + i8], i32
; CMP_xESIi8_i8		cmp	dword ptr [esi + i8], i8
; CMP_xESIi8_i32	cmp	dword ptr [esi + i8], i32
; NEG_xESIi8		neg	dword ptr [esi + i8]
; NOT_xESIi8		not	dword ptr [esi + i8]
; IMUL_xESIi8		imul	[esi + i8]
; IMUL_EAX_i8		imul	eax, i8
; IMUL_EAX_i32		imul	eax, i32
; SAL_xESIi8_n		sal	dword ptr [esi + i8], n
; SAR_xESIi8_n		sar	dword ptr [esi + i8], n
; IDIV_xESIi8		idiv	[esi + i8]
; IDIV_EAX_EBX		idiv	eax, ebx
; ADD_xESPi8_i8		add	dword ptr [esp + i8], i8
; INC_xEAXi8		inc	dword ptr [eax + i8]
; DEC_xEAXi8		dec	dword ptr [eax + i8]
; ADD_xEAXi8_i8		add	dword ptr [eax + i8], i8
; ADD_xEAXi8_i32	add	dword ptr [eax + i8], i32
; SUB_xEAXi8_i8		sub	dword ptr [eax + i8], i8
; SUB_xEAXi8_i32	sub	dword ptr [eax + i8], i32
; INC_xESIi8		inc	dword ptr [esi + i8]
; DEC_xESIi8		dec	dword ptr [esi + i8]
; ADD_ESI_i8		add	esi, i8
; SUB_ESI_i8		sub	esi, i8
; MOV_xESIi8_i32	mov	dword ptr [esi + i8], i32
; JE_rel8		je/jz	rel8
; JE_rel32		je/jz	rel32
; JNE_rel8		jne/jnz	rel8
; JNE_rel32		jne/jnz	rel32
; JMP_rel8		jmp	rel8
; JMP_rel32		jmp	rel32
; JG_rel8		jg	rel8
; JG_rel32		jg	rel32
; JGE_rel8		jge	rel8
; JGE_rel32		jge	rel32
; JL_rel8		jl	rel8
; JL_rel32		jl	rel32
; JLE_rel8		jle	rel8
; JLE_rel32		jle	rel32
; JA_rel8		ja	rel8
; JA_rel32		ja	rel32
; JAE_rel8		jae	rel8
; JAE_rel32		jae	rel32
; JB_rel8		jb	rel8
; JB_rel32		jb	rel32
; JBE_rel8		jbe	rel8
; JBE_rel32		jbe	rel32
; CALL_rel32		call	rel32
; OR_EAX_EAX		or	eax, eax
; MOV_xESIi8_EAX	mov	[esi + i8], eax
; MOV_xESIi8_EBX	mov	[esi + i8], ebx
; MOV_EAX_xEDIi32	mov	eax, [edi + i32]
; MOV_xMEM_i8		mov	[mem], i8
; BOUND_EAX_mem		bound	eax, qword ptr mem
; INTO_codeop
; _INTO_
; ENTER_n		enter	n, 0
; LEAVE			leave
; MOV_EAX_xEBPi8	mov	eax, [ebp + i8]
; MOV_xEBPi8_EAX	mov	[ebp + i8], eax
; ADD_xEBPi8_EAX	add	[ebp + i8], eax
; DEC_xEBP		dec	dword ptr [ebp + i8]
; INC_xEBP		dec	dword ptr [ebp + i8]
; CMP_EAX_i32		cmp	eax, i32
; CMP_EAX_xEBPi8	cmp	eax, [ebp + i8]
; CMP_xEBPi8_EAX	cmp	[esi + i8], eax
; CMP_xEBPi8_i8		cmp	dword ptr [ebp + i8], i8
; _CLD_			CLD
; _LODSD_		LODSD
; ADD_ESP_i8		ADD	esp, i8
; SUB_ESP_i8		ADD	esp, i8
; MOV_EAX_xESPi8	mov	eax, [esp + i8]
; MOV_xESPi8_EAX	mov	[esp + i8], eax
; ADD_xESPi8_EAX	add	[esp + i8], eax
; DEC_xESP		dec	dword ptr [esp + i8]
; INC_xESP		dec	dword ptr [esp + i8]
; _CDQ_			cdq
; XCHG_EAX_xESIi8	xchg	eax, [esi + i8]
; CLR_EBX		xor	ebx, ebx
; DEC_EBX		dec	ebx
; MOV_CL_AL		mov	cl, al
; MOV_EBX, EAX		mov	ebx, eax


		; --------------------
		; Store immediate byte
		; --------------------

StCodOp		MACRO	val
		push	ax
		mov	al, val
		call	CodeCComma					; CodeC,
		pop	ax
		ENDM


		; -------------------
		; Put 'RET' operation
		; -------------------
		
_RET_		MACRO
		StCodOp	0C3h
		ENDM


		; -------------------
		; Put 'NOP' operation
		; -------------------

NOP_CODOP	equ	090h		
_NOP_		MACRO	nb
		ifb	<nb>
			StCodOp	NOP_CODOP
		else
			REPT nb
				StCodOp	NOP_CODOP
			ENDM
		endif
		ENDM


		; ----------------------------
		; Put 'MOV EBX, i32' operation
		;	i32 into EAX
		; ----------------------------

MOV_EBX_i32	MACRO	i32
		StCodOp	0BBh
		call	CodeComma			; Code,
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [EAX + i8]' operation
		; -----------------------------------

MOV_EAX_xEAXi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'MOVZX EAX, byte ptr [EAX + i8]' operation
		; ----------------------------------------------

MOVZX_EAX_bxEAXi8	MACRO	i8
		StCodOp	00Fh
		StCodOp	0B6h
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'MOVZX EAX, word ptr [EAX + i8]' operation
		; ----------------------------------------------

MOVZX_EAX_wxEAXi8	MACRO	i8
		StCodOp	00Fh
		StCodOp	0B7h
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [EBX + i8]' operation
		; -----------------------------------

MOV_EAX_xEBXi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			if	i8 NE 0
				StCodOp	i8
			endif
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [ESI + i8]' operation
		; -----------------------------------

MOV_EAX_xESIi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EBX, [ESI + i8]' operation
		; -----------------------------------

MOV_EBX_xESIi8	MACRO	i8
		StCodOp	08Bh
		ifb	<i8>
			StCodOp	01Eh
		else
			StCodOp	05Eh
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV [EAX + i8], EBX' operation
		; -----------------------------------

MOV_xEAXi8_EBX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EAX + i8], BX' operation
		; ----------------------------------

MOV_xEAXi8_BX	MACRO	i8
		StCodOp	066h
		StCodOp	089h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EAX + i8], BL' operation
		; ----------------------------------

MOV_xEAXi8_BL	MACRO	i8
		StCodOp	088h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV [EBX + i8], EAX' operation
		; -----------------------------------

MOV_xEBXi8_EAX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EBX + i8], AX' operation
		; ----------------------------------

MOV_xEBXi8_AX	MACRO	i8
		StCodOp	066h
		StCodOp	089h
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'MOV [EBX + i8], AL' operation
		; ----------------------------------

MOV_xEBXi8_AL	MACRO	i8
		StCodOp	088h
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; ---------------------------------------------
		; Put 'MOV dword ptr [EAX + i8], i32' operation
		; ---------------------------------------------

MOV_xEAXi8_i32	MACRO	i8, i32
		StCodOp	0C7h
		if	i8 eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ifnb	<i32>
			push	eax
			mov	eax, i32
			call	CodeComma               		; Code,
			pop	eax
		endif
		ENDM


		; --------------------------------------------
		; Put 'MOV word ptr [EAX + i8], i16' operation
		; --------------------------------------------

MOV_wxEAXi8_i16	MACRO	i8, i16
		StCodOp	066h
		StCodOp	0C7h
		if	i8 eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ifnb	<i16>
			push	eax
			mov	ax, i16
			call	CodeWComma               		; CodeW,
			pop	eax
		endif
		ENDM


		; -------------------------------------------
		; Put 'MOV byte ptr [EAX + i8], i8' operation
		; -------------------------------------------

MOV_bxEAXi8_i8	MACRO	i8, i8b
		StCodOp	0C6h
		if	i8 eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ifnb	<i8b>
			push	eax
			mov	al, i8b
			call	CodeCComma               		; CodeC,
			pop	eax
		endif
		ENDM


		; -----------------------------------
		; Put 'ADD [EAX + i8], EBX' operation
		; -----------------------------------

ADD_xEAXi8_EBX	MACRO	i8
		StCodOp	001h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'SUB [EAX + i8], EBX' operation
		; -----------------------------------

SUB_xEAXi8_EBX	MACRO	i8
		StCodOp	029h
		ifb	<i8>
			StCodOp	018h
		else
			StCodOp	058h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'ADD [EBX + i8], EAX' operation
		; -----------------------------------

ADD_xEBXi8_EAX	MACRO	i8
		StCodOp	001h
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'SUB [EBX + i8], EAX' operation
		; -----------------------------------

SUB_xEBXi8_EAX	MACRO	i8
		StCodOp	029h
		ifb	<i8>
			StCodOp	003h
		else
			StCodOp	043h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'ADD [ESI + i8], EAX' operation
		; -----------------------------------

ADD_xESIi8_EAX	MACRO	i8
		StCodOp	001h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'SUB [ESI + i8], EAX' operation
		; -----------------------------------

SUB_xESIi8_EAX	MACRO	i8
		StCodOp	029h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'AND [ESI + i8], EAX' operation
		; -----------------------------------

AND_xESIi8_EAX	MACRO	i8
		StCodOp	021h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------
		; Put 'OR [ESI + i8], EAX' operation
		; ----------------------------------

OR_xESIi8_EAX	MACRO	i8
		StCodOp	009h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'XOR [ESI + i8], EAX' operation
		; -----------------------------------

XOR_xESIi8_EAX	MACRO	i8
		StCodOp	031h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'ADD dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

ADD_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'ADD dword ptr [ESI + i8], i32' operation
		; ---------------------------------------------

ADD_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------------
		; Put 'SUB dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

SUB_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	02Eh
		else
			StCodOp	06Eh
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'SUB dword ptr [ESI + i8], i32' operation
		; ---------------------------------------------

SUB_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	02Eh
		else
			StCodOp	06Eh
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------------
		; Put 'AND dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

AND_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	026h
		else
			StCodOp	066h
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'AND dword ptr [ESI + i8], i32' operation
		; ---------------------------------------------

AND_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	026h
		else
			StCodOp	066h
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ---------------------------------------------
		; Put 'OR dword ptr [ESI + i8a], i8b' operation
		; ---------------------------------------------

OR_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	00Eh
		else
			StCodOp	04Eh
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; --------------------------------------------
		; Put 'OR dword ptr [ESI + i8], i32' operation
		; --------------------------------------------

OR_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	00Eh
		else
			StCodOp	04Eh
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------------
		; Put 'XOR dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

XOR_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	036h
		else
			StCodOp	076h
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'XOR dword ptr [ESI + i8], i32' operation
		; ---------------------------------------------

XOR_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	036h
		else
			StCodOp	076h
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------------
		; Put 'CMP dword ptr [ESI + i8a], i8b' operation
		; ----------------------------------------------

CMP_xESIi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	03Eh
		else
			StCodOp	07Eh
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'CMP dword ptr [ESI + i8], i32' operation
		; ---------------------------------------------

CMP_xESIi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	03Eh
		else
			StCodOp	07Eh
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------
		; Put 'NEG dword ptr [esi + i8]' operation
		; ----------------------------------------

NEG_xESIi8	MACRO	i8
		StCodOp	0F7h
		ifb	<i8>
			StCodOp	01Eh
		else
			StCodOp	05Eh
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'NOT dword ptr [esi + i8]' operation
		; ----------------------------------------

NOT_xESIi8	MACRO	i8
		StCodOp	0F7h
		ifb	<i8>
			StCodOp	016h
		else
			StCodOp	056h
			StCodOp	i8
		endif
		ENDM


		; -------------------------------
		; Put 'IMUL [ESI + i8]' operation
		; -------------------------------

IMUL_xESIi8	MACRO	i8
		StCodOp	0F7h
		ifb	<i8>
			StCodOp	02Eh
		else
			StCodOp	06Eh
			mov	al, i8
			call	CodeCComma		; CodeC,
		endif
		ENDM


		; ----------------------------
		; Put 'IMUL EAX, i8' operation
		;	Imm value in AL
		; ----------------------------

IMUL_EAX_i8	MACRO	i8
		StCodOp	06Bh
		StCodOp	0C0h
		call	CodeCComma			; CodeC,
		ENDM


		; -----------------------------
		; Put 'IMUL EAX, i32' operation
		;	Imm value in EAX
		; -----------------------------

IMUL_EAX_i32	MACRO	imm
		StCodOp	069h
		StCodOp	0C0h
		call	CodeComma			; Code,
		ENDM


		; -------------------------------------------
		; Put 'SAL DWORD PTR [ESI + i8], n' operation
		; -------------------------------------------

SAL_xESIi8_n	MACRO	i8, n
		if	n eq 1
			StCodOp	0D1h
			if	i8 eq 0
				StCodOp	026h
			else
				StCodOp	066h
				mov	al, i8
				call	CodeCComma		; CodeC,
			endif
		else
			StCodOp	0C1h
			if	i8 eq 0
				StCodOp	026h
				mov	al, n
				call	CodeCComma		; CodeC,
			else
				StCodOp	066h
				mov	al, i8
				call	CodeCComma		; CodeC,
				mov	al, n
				call	CodeCComma		; CodeC,
			endif
		endif
		ENDM


		; -----------------------------
		; Put 'IMUL EAX, i32' operation
		;	Imm value in EAX
		; -----------------------------

IDIV_EAX_i32	MACRO	imm
		StCodOp	069h
		StCodOp	0C0h
		call	CodeComma			; Code,
		ENDM


		; -----------------------------------------
		; Put 'IDIV dword ptr [ESI + i8]' operation
		; -----------------------------------------

IDIV_xESIi8	MACRO	i8
		StCodOp	0F7h
		ifb	<i8>
			StCodOp	03Eh
		else
			StCodOp	07Eh
			StCodOp	i8
		endif
		ENDM


		; -----------------------------
		; Put 'IDIV EAX, EBX' operation
		; ----------------------------

IDIV_EAX_EBX	MACRO	i8
		StCodOp	0F7h
		StCodOp	0FBh
		ENDM


		; -------------------------------------------
		; Put 'SAR DWORD PTR [ESI + i8], n' operation
		; -------------------------------------------

SAR_xESIi8_n	MACRO	i8, n
		if	n eq 1
			StCodOp	0D1h
			if	i8 eq 0
				StCodOp	03Eh
			else
				StCodOp	07Eh
				mov	al, i8
				call	CodeCComma		; CodeC,
			endif
		else
			StCodOp	0C1h
			if	i8 eq 0
				StCodOp	03Eh
				mov	al, n
				call	CodeCComma		; CodeC,
			else
				StCodOp	07Eh
				mov	al, i8
				call	CodeCComma		; CodeC,
				mov	al, n
				call	CodeCComma		; CodeC,
			endif
		endif
		ENDM


		; ------------------------------------
		; Put 'ADD DWORD PTR [esp + i8a], i8b'
		; ------------------------------------
		
ADD_xESPi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	004h
			StCodOp	024h
			StCodOp	i8b
		else
			StCodOp	044h
			StCodOp	024h
			StCodOp	i8a
			StCodOp	i8b
		endif
		ENDM


		; ----------------------------------------
		; Put 'INC dword ptr [EAX + i8]' operation
		; ----------------------------------------

INC_xEAXi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'DEC dword ptr [EAX + i8]' operation
		; ----------------------------------------

DEC_xEAXi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	008h
		else
			StCodOp	048h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------------
		; Put 'ADD dword ptr [EAX + i8a], i8b' operation
		; ----------------------------------------------

ADD_xEAXi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'ADD dword ptr [EAX + i8], i32' operation
		; ---------------------------------------------

ADD_xEAXi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	000h
		else
			StCodOp	040h
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------------
		; Put 'SUB dword ptr [EAX + i8a], i8b' operation
		; ----------------------------------------------

SUB_xEAXi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		if	i8a eq 0
			StCodOp	028h
		else
			StCodOp	068h
			StCodOp	i8a
		endif
		ifnb	<i8b>
			mov	al, i8b
		endif
		call	CodeCComma			; CodeC,
		ENDM


		; ---------------------------------------------
		; Put 'SUB dword ptr [EAX + i8], i32' operation
		; ---------------------------------------------

SUB_xEAXi8_i32	MACRO	i8a, i32
		StCodOp	081h
		if	i8a eq 0
			StCodOp	028h
		else
			StCodOp	068h
			StCodOp	i8a
		endif
		ifnb	<i32>
			mov	eax, i32
		endif
		call	CodeComma			; Code,
		ENDM


		; ----------------------------------------
		; Put 'INC dword ptr [ESI + i8]' operation
		; ----------------------------------------

INC_xESIi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; ----------------------------------------
		; Put 'DEC dword ptr [ESI + i8]' operation
		; ----------------------------------------

DEC_xESIi8	MACRO	i8
		StCodOp	0FFh
		ifb	<i8>
			StCodOp	00Eh
		else
			StCodOp	04Eh
			StCodOp	i8
		endif
		ENDM


		; ---------------------------
		; Put 'ADD ESI, i8' operation
		; ---------------------------
		
ADD_ESI_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0C6h
		StCodOp	i8
		ENDM
		

		; ---------------------------
		; Put 'SUB ESI, i8' operation
		; ---------------------------
		
SUB_ESI_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0EEh
		StCodOp	i8
		ENDM


		; ---------------------------------------------
		; Put 'MOV DWORD PTR [ESI + i8], i32' operation
		; ---------------------------------------------
		
MOV_xESIi8_i32	MACRO	i8
		StCodOp	0C7h
 		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM
		

		; ----------------------------
		; Put 'JE rel8' code operation		
		; ----------------------------
		
JErel8_codop	equ	074h
JE_rel8		MACRO	rel8
		StCodOp	JErel8_codop
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JE rel32' code operation		
		; -----------------------------
		
JE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	084h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JNE rel8' code operation		
		; -----------------------------
		
JNE_rel8	MACRO	rel8
		StCodOp	075h
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JE rel32' code operation		
		; -----------------------------
		
JNE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	085h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JMP rel8' code operation		
		; -----------------------------

JMPrel8_CODOP	equ	0EBh
JMP_rel8	MACRO
		StCodOp	JMPrel8_CODOP
		ENDM


		; ------------------------------
		; Put 'JMP rel32' code operation		
		; ------------------------------

JMPr32_CODOP	equ	0E9h
JMP_rel32	MACRO
		StCodOp	JMPr32_CODOP
		ENDM


		; ----------------------------
		; Put 'JG rel8' code operation
		; ----------------------------
		
JG_rel8		MACRO	rel8
		StCodOp	07Fh
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JG rel32' code operation
		; -----------------------------
		
JG_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	08Fh
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JGE rel8' code operation
		; -----------------------------
		
JGE_rel8	MACRO	rel8
		StCodOp	07Dh
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; ------------------------------
		; Put 'JGE rel32' code operation
		; ------------------------------
		
JGE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	08Dh
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; ----------------------------
		; Put 'JL rel8' code operation
		; ----------------------------
		
JL_rel8		MACRO	rel8
		StCodOp	07Ch
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JL rel32' code operation
		; -----------------------------
		
JL_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	08Ch
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JLE rel8' code operation
		; -----------------------------
		
JLE_rel8	MACRO	rel8
		StCodOp	07Eh
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; ------------------------------
		; Put 'JLE rel32' code operation
		; ------------------------------
		
JLE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	08Eh
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; ----------------------------
		; Put 'JA rel8' code operation
		; ----------------------------
		
JA_rel8		MACRO	rel8
		StCodOp	077h
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JA rel32' code operation
		; -----------------------------
		
JA_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	087h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JAE rel8' code operation
		; -----------------------------
		
JAE_rel8	MACRO	rel8
		StCodOp	073h
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; ------------------------------
		; Put 'JAE rel32' code operation
		; ------------------------------
		
JAE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	083h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; ----------------------------
		; Put 'JB rel8' code operation
		; ----------------------------
		
JB_rel8		MACRO	rel8
		StCodOp	072h
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; -----------------------------
		; Put 'JB rel32' code operation
		; -----------------------------
		
JB_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	082h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -----------------------------
		; Put 'JBE rel8' code operation
		; -----------------------------
		
JBE_rel8	MACRO	rel8
		StCodOp	076h
		ifnb	<rel8>
			mov	al, rel8
			call	CodeCComma	             		; CodeC,
		endif
		ENDM


		; ------------------------------
		; Put 'JBE rel32' code operation
		; ------------------------------
		
JBE_rel32	MACRO	rel32
		StCodOp	00Fh
		StCodOp	086h
		ifnb	<rel32>
			mov	eax, rel32
			call	CodeComma	             		; Code,
		endif
		ENDM


		; -------------------------------
		; Put 'CALL rel32' code operation
		; -------------------------------
		
CALLr32_CODOP	equ	0E8h
CALL_rel32	MACRO
		StCodOp	CALLr32_CODOP
		ENDM


		; ---------------------------
		; Put 'OR EAX, EAX' operation
		; ---------------------------
		
OR_EAX_EAX	MACRO
		StCodOp	00Bh
		StCodOp	0C0h
		ENDM


		; -----------------------------------
		; Put 'MOV [ESI + i8], EAX' operation
		; -----------------------------------

MOV_xESIi8_EAX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			StCodOp	i8
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV [ESI + i8], EBX' operation
		; -----------------------------------

MOV_xESIi8_EBX	MACRO	i8
		StCodOp	089h
		ifb	<i8>
			StCodOp	01Eh
		else
			StCodOp	05Eh
			StCodOp	i8
		endif
		ENDM


		; ------------------------------------
		; Put 'MOV EAX, [EDI + i32]' operation
		; ------------------------------------

MOV_EAX_xEDIi32	MACRO
		StCodOp	08Bh
		StCodOp	087h
		ENDM


		; --------------------------------
		; Put 'MOV [memory], i8' operation
		; --------------------------------

MOV_xMEM_i8	MACRO
		StCodOp	0C6h
		StCodOp	005h
							; Then: rel32  (memory relative address)
							; Then: i8
		ENDM

		
		; ----------------------------------------
		; Put 'BOUND eax, qword ptr mem' operation
		; ----------------------------------------

BOUND_EAX_mem	MACRO	mem
		StCodOp	062h
		StCodOp	005h
		push	eax
		mov	eax, offset mem
		call	CodeComma               		; Code,
		pop	eax
		ENDM

		
		; --------------------------
		; Put 'CALL_rel32' procedure
		; --------------------------

compCALL_rel32	MACRO	function
		CALL_rel32
		push	eax
		ifnb	<function>
			lea	eax, function
			add	eax, [OfsDictReloc]
		endif
		sub	eax, [CDA_START]
		sub	eax, [CDA_SIZE]
		sub	eax, 4					; 4 is for REL32
		call	CodeComma               		; Code,
		pop	eax
		ENDM


		; -------------------------
		; Put 'JMP_rel32' procedure
		; -------------------------

compJMP_rel32	MACRO	function
		JMP_rel32
		push	eax
		lea	eax, function
		add	eax, [OfsDictReloc]
		sub	eax, [CDA_START]
		sub	eax, [CDA_SIZE]
		sub	eax, 4					; 4 is for REL32
		call	CodeComma               		; Code,
		pop	eax
		ENDM
		
		
		; -----------------------
		; Code operation for INTO
		; -----------------------

INTO_codeop	equ	0CEh
		

		; --------------------
		; Put 'INTO' operation
		; --------------------

_INTO_		MACRO
		mov	al, INTO_codeop
		call	CodeCComma					; CodeC,
		ENDM


		; --------------------------
		; Put 'ENTER n, 0' operation
		; --------------------------

ENTER_n		MACRO	sz
		StCodOp	0C8h
		ifnb	<sz>
			mov	eax, sz
			call	CodeWComma			; CodeW,
			clr	al
			call	CodeCComma			; CodeC,
		endif
		ENDM

	
		; ---------------------
		; Put 'LEAVE' operation
		; ---------------------

_LEAVE_		MACRO
		StCodOp	0C9h
		ENDM

	
		; -----------------------------------
		; Put 'MOV EAX, [EBP + i8]' operation
		; -----------------------------------

MOV_EAX_xEBPi8	MACRO	i8
		StCodOp	08Bh
		StCodOp	045h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM

	
		; -----------------------------------
		; Put 'MOV [EBP + i8], EAX' operation
		; -----------------------------------

MOV_xEBPi8_EAX	MACRO	i8
		StCodOp	089h
		StCodOp	045h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM

	
		; -----------------------------------
		; Put 'ADD [EBP + i8], EAX' operation
		; -----------------------------------

ADD_xEBPi8_EAX	MACRO	i8
		StCodOp	001h
		StCodOp	045h
		mov	al, i8
		call	CodeCComma				; CodeC,
		ENDM

	
		; ----------------------------------------
		; Put 'DEC DWORD PTR [EBP + i8]' operation
		;	DO NOT FORGET TO STORE i8
		; ----------------------------------------

DEC_xEBP	MACRO	i8
		StCodOp	0FFh
		StCodOp	04Dh
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; ----------------------------------------
		; Put 'INC DWORD PTR [EBP + i8]' operation
		;	DO NOT FORGET TO STORE i8
		; ----------------------------------------

INC_xEBP	MACRO	i8
		StCodOp	0FFh
		StCodOp	045h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; ----------------------------
		; Put 'CMP EAX, i32' operation
		; ----------------------------

CMP_EAX_i32	MACRO	i32
		StCodOp	03Dh
		ifnb	<i32>
			mov	eax, i32
			call	CodeComma			; Code,
		endif
		ENDM


		; -----------------------------------
		; Put 'CMP EAX, [EBP + i8]' operation
		; -----------------------------------

CMP_EAX_xEBPi8	MACRO	i8
		StCodOp	03Bh
		StCodOp	045h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; -----------------------------------
		; Put 'CMP [ESI + i8], EAX' operation
		; -----------------------------------

CMP_xESIi8_EAX	MACRO	i8
		StCodOp	039h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; ---------------------------------------------
		; Put CMP DWORD PTR [EBP + i8a], i8b' operation
		; ---------------------------------------------

CMP_xEBPi8_i8	MACRO	i8a, i8b
		StCodOp	083h
		StCodOp	07Dh
		mov	ax, (i8a + i8b shl 8)
		call	CodeWComma				; CodeW,
		ENDM

	
		; -------------------
		; Put 'CLD' operation
		; -------------------

_CLD_		MACRO
		StCodOp	0FCh
		ENDM


		; ---------------------
		; Put 'LODSD' operation
		; ---------------------

_LODSD_		MACRO
		StCodOp	0ADh
		ENDM


		; ---------------------------
		; Put 'ADD ESP, i8' operation
		; ---------------------------

ADD_ESP_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0C4h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; ---------------------------
		; Put 'SUB ESP, i8' operation
		; ---------------------------

SUB_ESP_i8	MACRO	i8
		StCodOp	083h
		StCodOp	0ECh
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; -----------------------------------
		; Put 'MOV EAX, [ESP + i8]' operation
		; -----------------------------------

MOV_EAX_xESPi8	MACRO	i8
		StCodOp	08Bh
		StCodOp	044h
		StCodOp	024h
		mov	al, i8
		call	CodeCComma				; CodeC,
		ENDM


		; -----------------------------------
		; Put 'MOV [ESP + i8], EAX' operation
		; -----------------------------------

MOV_xESPi8_EAX	MACRO	i8
		StCodOp	089h
		StCodOp	044h
		StCodOp	024h
		mov	al, i8
		call	CodeCComma				; CodeC,
		ENDM


		; -----------------------------------
		; Put ADD [ESP + i8], EAX' operation
		; -----------------------------------

ADD_xESPi8_EAX	MACRO	i8
		StCodOp	001h
		StCodOp	044h
		StCodOp	024h
		mov	al, i8
		call	CodeCComma				; CodeC,
		ENDM


		; ----------------------------------------
		; Put 'DEC DWORD PTR [ESP + i8]' operation
		; ----------------------------------------

DEC_xESP	MACRO	i8
		StCodOp	0FFh
		StCodOp	04Ch
		StCodOp	024h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma			; CodeC,
		endif
		ENDM


		; ----------------------------------------
		; Put 'INC DWORD PTR [ESP + i8]' operation
		; ----------------------------------------

INC_xESP	MACRO	i8
		StCodOp	0FFh
		StCodOp	044h
		StCodOp	024h
		ifnb	<i8>
			mov	al, i8
			call	CodeCComma				; CodeC,
		endif
		ENDM


		; ----------------------------------
		; Compile 32-bits literal (from EAX)
		; ----------------------------------

COMP_NB		macro
		local	safe_done

		; Put 'SUB ESI, 4'
		SUB_ESI_i8	@WordSize
		
		; Put 'MOV DWORD PTR [ESI], IMM32'
		MOV_xESIi8_i32
		call		CodeComma              			; Code,

		call		isSafe
		jnc		safe_done
		compCALL_rel32	OStack					; CALL   OStack
safe_done:

		ENDM


		; -------------------
		; Put 'CDQ' operation
		; -------------------

_CDQ_		MACRO
		StCodOp	099h
		ENDM


		; ------------------------------------
		; Put 'XCHG EAX, [ESI + i8]' operation
		; ------------------------------------

XCHG_EAX_xESIi8	MACRO	i8
		StCodOp	087h
		ifb	<i8>
			StCodOp	006h
		else
			StCodOp	046h
			mov	al, i8
			call	CodeCComma				; CodeC,
		endif
		ENDM


		; -----------------------
		; Put 'CLR EBX' operation
		; -----------------------

CLR_EBX		MACRO
		StCodOp	033h
		StCodOp	0DBh
		ENDM


		; -----------------------
		; Put 'DEC EBX' operation
		; -----------------------

DEC_EBX		MACRO
		StCodOp	04Bh
		ENDM


		; --------------------------
		; Put 'MOV CL, AL' operation
		; --------------------------

MOV_CL_AL	MACRO
		StCodOp	08Ah
		StCodOp	0C8h
		ENDM


		; ----------------------------
		; Put 'MOV EBX, EAX' operation
		; ----------------------------

MOV_EBX_EAX	MACRO
		StCodOp	08Bh
		StCodOp	0D8h
		ENDM


