		; ------------
		; Used by VS2b
		; ------------

		; values for VGA Graphics Controller Read-Modify-Write bits
		; ---------------------------------------------------------
		
RMW_REPLACE	equ	00h
RMW_AND 		equ	08h
RMW_OR		equ	10h
RMW_XOR 		equ	18h


		; video state parameters
		; ----------------------
		
VIDEOSTATEPARAMS	struc
	vsp_VBuf 	dd	    0A0000h  	; display start segment
	vsp_PageSz	dw           06D60h	; Size of a page
	vsp_usPPB	dw	    0	    	; pixels per byte
	vsp_cbRow	dw	    0	    	; bytes per logical row
	vsp_usCX		dw	    0	    	; buffer dimensions
	vsp_usCY		dw	    0
	vsp_usSX		dw	    0	    	; screen dimensions
	vsp_usSY		dw	    0
	vsp_usX		dw	    0	    	; logical pixel origin
	vsp_usY		dw	    0
	vsp_ofsXY	dw	    0	    	; byte offset of origin pixel
	vsp_usVNSkip	dw	    0	    	; vert nondisplay timer skip count
	vsp_cBPP		db	    0	    	; bits per pixel
	vsp_cRMW		db	    00h     	; Read-Modify-Write bits
VIDEOSTATEPARAMS	ends

	
		; BIOS Video Display Data Area
		; ----------------------------
		
segVDDA 		equ	40h
EQUIP_FLAG	equ	10h
CRT_MODE		equ	49h
CRT_COLS		equ	4Ah
CRT_LEN 		equ	4Ch
CRT_START	equ	4Eh
CURSOR_POSN	equ	50h
CURSOR_MODE	equ	60h
ACTIVE_PAGE	equ	62h
ADDR6845		equ	63h	    ; (CRTC I/O address)
CRT_MODE_SET	equ	65h
CRT_PALETTE	equ	66h
ROWS		equ	84h
POINTS		equ	85h
INFO		equ	87h
INFO_3		equ	88h


		; defined for MS Windows 3.x ...
		; ------------------------------
		
BITMAPINFOHEADER	struc
	biSize		dd	?
	biWidth 		dd	?
	biHeight		dd	?
	biPlanes		dw	?
	biBitCount	dw	?
	biCompression	dd	?
	biSizeImage	dd	?
	biXPelsPerMeter	dd	?
	biYPelsPerMeter	dd	?
	biClrUsed	dd	?
	biClrImportant	dd	?
BITMAPINFOHEADER	ends

BI_RGB		equ	0
BI_RLE8		equ	1
BI_RLE4		equ	2

		
		; Video region structure
		; ----------------------

VideoRegion	struc
	vr_psBMP		BITMAPINFOHEADER 1 dup (<>)
VideoRegion	ends


		; Sprite structure
		; ----------------

SPRITE_XMAX	equ	250
SPRITE_YMAX	equ	250
SPRITE_COLORSMAX	equ	16
sprite		struc
	sprite_sign	dd	'SprT'				; Signature
	sprite_initdone	db	?				; Sprite initialized ?
	sprite_dx	dw	?				; X size (width)
	sprite_dy	dw	?				; Y size (height)
	sprite_chars	db	SPRITE_COLORSMAX dup (?)		; Chars defining colors
	sprite_colors	db	SPRITE_COLORSMAX dup (?)		; Colors
	sprite_videoofs	dd	?				; Offset to give relative address to sprite_videosize
	sprite_videosize	dd	?				; Size of video buffer
		ends


ifdef __HGR__

		; Graphics modes definitions
		align	4
VSP_320x200x16	VIDEOSTATEPARAMS < ,      0, 8,  40, 320, 1638, 320, 200,,,,, 4, RMW_REPLACE >
		align	4
VSP_640x200x16	VIDEOSTATEPARAMS < ,      0, 8,  80, 640,  819, 640, 200,,,,, 4, RMW_REPLACE >
		align	4
VSP_640x350x4	VIDEOSTATEPARAMS < ,      0, 8,  80, 640,  819, 640, 350,,,,, 1, RMW_REPLACE >
		align	4
VSP_640x350x16	VIDEOSTATEPARAMS < , 08000h, 8,  80, 640,  819, 640, 350,,,,, 4, RMW_REPLACE >
		align	4
VSP_640x480x2	VIDEOSTATEPARAMS < ,      0, 8,  80, 640,  819, 640, 480,,,,, 1, RMW_REPLACE >
		align	4
VSP_640x480x16	VIDEOSTATEPARAMS < ,      0, 8,  80, 640,  819, 640, 480,,,,, 4, RMW_REPLACE >
		align	4
VSP_320x200x256	VIDEOSTATEPARAMS < ,      0, 1, 320, 320,  204, 320, 200,,,,, 8, RMW_REPLACE >
		align	4
VSP_640x400x256	VIDEOSTATEPARAMS < ,      0, 1, 640, 640,  400, 640, 400,,,,, 8, RMW_REPLACE >
		align	4
VSP_800x600x16	VIDEOSTATEPARAMS < ,      0, 8, 100, 800,  600, 800, 600,,,,, 4, RMW_REPLACE >
		align	4
VSP		VIDEOSTATEPARAMS	<?>

		; Pointer to graphics specific functions
		align	4
_clear_		dd	?
_setpix_		dd	?
_getpix_		dd	?
_line_		dd	?
_getvideo_	dd	?
_putvideo_	dd	?

		; Clipping region
		align	4
_clip_x0		dw	?
		align	4
_clip_y0		dw	?
		align	4
_clip_x1		dw	?
		align	4
_clip_y1		dw	?

endif

global	VSP_320x200x16:	VIDEOSTATEPARAMS
global	VSP_640x200x16:	VIDEOSTATEPARAMS
global	VSP_640x350x4:	VIDEOSTATEPARAMS
global	VSP_640x350x16:	VIDEOSTATEPARAMS
global	VSP_640x480x2:	VIDEOSTATEPARAMS
global	VSP_640x480x16:	VIDEOSTATEPARAMS
global	VSP_320x200x256:	VIDEOSTATEPARAMS
global	VSP_800x600x16:	VIDEOSTATEPARAMS
global	VSP:		VIDEOSTATEPARAMS

global	_GraphModeNotSet:	proc
global	_NotImplemented:	proc

global	INITVNWAIT:	proc
global	VNWAIT:		proc
global	PixelAddr_10:	proc
global	PixelAddr_13:	proc

global	FillVBuff_10:	proc
global	FillVBuff_13:	proc

global	SetPixel_10:	proc
global	SetPixel_13:	proc

global	GetPixel_10:	proc
global	GetPixel_13:	proc

global	Line_10:		proc
global	Line_13:		proc

global	_BLTTORAM_10:	proc
global	_BLTTOVBUFF_10:	proc

global	_clear_:		dword
global	_setpix_:	dword
global	_getpix_:	dword
global	_line_:		dword
global	_getvideo_:	dword
global	_putvideo_:	dword

global	_hwidth:		dword
global	_hheight:	dword

global	_gopmode:	byte

global	_clip_x0:	word
global	_clip_y0:	word
global	_clip_x1:	word
global	_clip_y1:	word

